/////////////////////////////////////////////////////////////////////////////
// FastGUI by JB Systems                                                   //
// written by James R. Boer                                                //
// version 1.00a                                                           //
// 4/10/96                                                                 //
//                                                                         //
// FastGUI is a C++ class library designed to work with the Fastgraph(r)   //
// graphics library for DOS version 4.0 or later.  Fastgraph is produced   //
// by Ted Gruber Software and is not affiliated with JB Systems in any     //
// way.  All FastGUI files. libraries, and documentation are copyrighted.  //
// Copyright (c) 1996 James R. Boer  All Rights Reserved                   //
/////////////////////////////////////////////////////////////////////////////

#include <iostream.h>
#include <dos.h>
#include <stdlib.h>
#include <string.h>
#include <fastgui.h>


void main(int argc, char* argv[])
   {
   long count;
   int id, major, minor;

   struct dosdate_t date;

   /* Get and display the current date and time */
   _dos_getdate( &date );

   cout << endl << "The current date is: " << int(date.month) << "-" << int(date.day) << "-" << date.year
      << endl << endl;
      
   if((date.year > 1996) && (date.month > 4))
      {
      cout << "It has been over a year since this demo program was released.  The information"
         << endl << "contained in it may no longer be valid.  Please contact JB Systems for the"
         << endl << "most current version of this program." << endl;
      cout << endl << "Press any key to continue..." << endl;
      fg_waitkey();
      cout << endl;
      }
   
                                  
   char *description[] =
      {
      "cannot be determined",
      "VESA",
      "Ahead A",
      "Ahead B",
      "ATI 18800",
      "ATI 18800-1",
      "ATI 28800/38800",
      "Chips & Technologies 82c451/455/456/457",
      "Chips & Technologies 82c452",
      "Chips & Technologies 82c450/453",
      "Genoa 6000 series",
      "Oak OTI-067",
      "Paradise PVGA1a",
      "Paradise WD90C00/WD90C10",
      "Paradise WD90C11/30/31/33",
      "Trident 8800",
      "Trident 8900/9000",
      "Tseng ET3000",
      "Tseng ET4000",
      "Video7",
      "Cirrus Logic 5400 series",
      "S3",
      "NCR 77C22/77C32",
      "Oak OTI-077",
      "Oak OTI-087",
      " ",
      "Cirrus Logic 6400 series",
      "Avance Logic 2000 series",
      "ARK Logic 1000/2000",
      "ATI 68800 (mach32)",
      "ATI 88800 (mach64)",
      "Chips & Technologies 64000/65500 series",
      "Realtek 3100 series"
      };

  fg_initpm();
  if(argc == 1)
      {
      id = fg_svgainit(0);
      cout << "SVGA chipset:  " << description[id] << endl;
      cout << "video memory:  " << fg_memory() << endl;
      fg_svgaver(&major,&minor);
      cout << "SVGA version:  " << major << "." << minor << endl;
      fg_waitfor(36);
      if(id == 0)
         {
         cout << endl << "SVGA mode not available.  Running in VGA mode...";
         fg_waitfor(36);
         fg_setmode(18);
         }
      else
         fg_setmode(25);         
      }
   else if(argc == 2)
      {
      if(strcmpi(argv[1], "?") == 0 || strcmpi(argv[1], "/?") == 0 || strcmpi(argv[1], "-?") == 0)
         {
         cout << endl << "GUITEST Command-line argument help" << endl;
         cout << "--------------------------" << endl;
         cout << "Usage: GUITEST /VGA" << endl; 
         cout << "or" << endl;
         cout << "Usage: GUITEST <chipset initialization number>" << endl;
         cout << " 0 = autodetect with chipset preference" << endl;
         cout << " 1 = VESA" << endl;
         cout << " 2 = Ahead A" << endl;
         cout << " 3 = Ahead B" << endl;
         cout << " 4 = ATI 18800" << endl;
         cout << " 5 = ATI 18800-1" << endl;
         cout << " 6 = ATI 28800/38800" << endl;
         cout << " 7 = Chips & Technologies 82c451/455/456/457" << endl;
         cout << " 8 = Chips & Technologies 82c452" << endl;
         cout << " 9 = Chips & Technologies 82c450/453" << endl;
         cout << " 10 = Genoa 6000 series" << endl;
         cout << " 11 = Oak OTI-067" << endl;
         cout << " 12 = Paradise PVGA1a" << endl;
         cout << " 13 = Paradise WD90C00/WD90C10" << endl;
         cout << " 14 = Paradise WD90C11/30/31/33" << endl;
         cout << " 15 = Trident 8800" << endl;
         cout << " 16 = Trident 8900/9000" << endl;
         cout << " 17 = Tseng ET3000" << endl;
         cout << " 18 = Tseng ET4000" << endl;
         cout << "Press any key to continue..." << endl;
         fg_waitkey();
         cout << " 19 = Video7" << endl;
         cout << " 20 = Cirrus Logic 5400 series" << endl;
         cout << " 21 = S3" << endl;
         cout << " 22 = NCR 77C22/77C32" << endl;
         cout << " 23 = Oak OTI-077" << endl;
         cout << " 24 = Oak OTI-087" << endl;
         cout << " 25 = reserved" << endl;
         cout << " 26 = Cirrus Logic 6400 series" << endl;
         cout << " 27 = Avance Logic 2000 series" << endl;
         cout << " 28 = ARK Logic 1000/2000" << endl;
         cout << " 29 = ATI 68800 (mach32)" << endl;
         cout << " 30 = ATI 88800 (mach64)" << endl;
         cout << " 31 = Chips & Technologies 64000/65500 series" << endl;
         cout << " 32 = Realtek 3100 series" << endl;
         exit(0);
         }
      else if(strcmpi(argv[1], "VGA") == 0 || strcmpi(argv[1], "/VGA") == 0 || strcmpi(argv[1], "-VGA") == 0)   
         {
         cout << "Initializing in VGA mode" << endl;
         fg_waitfor(36);
         fg_setmode(18);
         }   
      else
         {
         if(fg_svgainit(atoi(argv[1])) == 0)
            FScreen::HandleError("Video Mode not available");
         else
            cout << "Initializing " << description[atoi(argv[1])] << " chipset-based video card";
            fg_waitfor(36);
            fg_setmode(25); 
         }
      }

   FScreen::Initialize(F_FONTS | F_AUTOSAVE | F_MOUSE);

   #ifdef FG32
      FScreen::SetMaxBufferLength(0xFFFFF);
   #endif

   FBackground* Background1 = new FBackground("FastGUI Demonstration Program");

   // constructor for menu bar
   FMenuBar* MenuBar1 = new FMenuBar(Background1);
   // constructors for menu bar items
   FMenuItem* MenuItem1 = new FMenuItem(MenuBar1, "Demonstration",
      F_MENU_BAR);
   FMenuItem* MenuItem2 = new FMenuItem(MenuBar1, "Help", F_MENU_BAR);
   // constructors for first pulldown menu
   FPullDownMenu* PullDownMenu1 = new FPullDownMenu(MenuItem1);
   FMenuItem* MenuItem3 = new FMenuItem(PullDownMenu1, "Standard Elements...",
      F_PULLDOWN_MENU);
   FMenuItem* MenuItem4 = new FMenuItem(PullDownMenu1, "Graphic Elements...",
      F_PULLDOWN_MENU);
   FMenuItem* MenuItem5 = new FMenuItem(PullDownMenu1, "Message Box...",
      F_PULLDOWN_MENU);
   FMenuItem* MenuItem6 = new FMenuItem(PullDownMenu1, "Fade Out/In",
      F_PULLDOWN_MENU);
   FMenuItem* MenuItem7 = new FMenuItem(PullDownMenu1, "Error Handling...",
      F_PULLDOWN_MENU | F_SEPARATOR);
   FMenuItem* MenuItem8 = new FMenuItem(PullDownMenu1, "Exit", F_PULLDOWN_MENU);
   // constructors for second pulldown menus
   FPullDownMenu* PullDownMenu2 = new FPullDownMenu(MenuItem2);
   FMenuItem* MenuItem9 = new FMenuItem(PullDownMenu2, "Contents...",
      F_PULLDOWN_MENU);
   FMenuItem* MenuItem10 = new FMenuItem(PullDownMenu2, "Ordering Information...",
      F_PULLDOWN_MENU);
   FMenuItem* MenuItem11 = new FMenuItem(PullDownMenu2, "About...", F_PULLDOWN_MENU);
   if(fg_getmode() == 18)
      MenuItem11->SetDisabled(1);


   FDialogBox* DialogBox1 = new FDialogBox(Background1, 0, 0, 300, 300,
      "Standard Elements");
   DialogBox1->Center();
   FButton* Button1 = new FButton(DialogBox1, 15, 250, "OK");
   FButton* Button2 = new FButton(DialogBox1, 110, 250, "Cancel");
   FButton* Button3 = new FButton(DialogBox1, 205, 250, "Help");
   FTextEntryField* TEField1 = new FTextEntryField(DialogBox1, 70, 60, 180,
      40, "Text");
   TEField1->SetEntry("Default Entry");
   FCheckBox* CheckBox1 = new FCheckBox(DialogBox1, 30, 110, "Check Box");
   FRadioButtonGroup* RBGroup1 = new FRadioButtonGroup(DialogBox1, 30, 150);
   FRadioButton* RadioButton1 = new FRadioButton(RBGroup1, "Radio Button 1");
   FRadioButton* RadioButton2 = new FRadioButton(RBGroup1, "Radio Button 2");
   FRadioButton* RadioButton3 = new FRadioButton(RBGroup1, "Radio Button 3");
   FSlider* Slider1 = new FSlider(DialogBox1, 160, 145, 0, 4, 20);
   FSlider* Slider2 = new FSlider(DialogBox1, 160, 180, 0, 16, 5);
   FBorder* Border1 = new FBorder(DialogBox1, 10, 40, 280, 195, "Controls");
   FProgressBar* ProgressBar1 = new FProgressBar(DialogBox1, 160, 110, 103);


   FDialogBox* DialogBox2 = new FDialogBox(Background1, 0, 0, 300, 300,
      "Graphic Elements");
   DialogBox2->Center();
   FButton* Button4 = new FButton(DialogBox2, 110, 250, "Close");
   FCheckBox* CheckBox2 = new FCheckBox(DialogBox2, 35, 80,
      "Disable Graphic Button");
   FGraphicButton* GraphicButton1 = new FGraphicButton(DialogBox2, 195, 70, 38,
      38, F_GO_ICON, 32, 32, F_STOP_ICON, 32, 32);
   FRadioButtonGroup* RBGroup2 = new FRadioButtonGroup(DialogBox2, 35, 160);
   FRadioButton* RadioButton4 = new FRadioButton(RBGroup2, "Green Button");
   FRadioButton* RadioButton5 = new FRadioButton(RBGroup2, "Red Button");
   FColorButton* ColorButton1 = new FColorButton(DialogBox2, 180, 155, 90, 50,
      "Color Button");
   ColorButton1->SetColor(F_LIGHT_GREEN, F_WHITE, F_GREEN, F_BLACK, F_BLACK);
   FBorder* Border2 = new FBorder(DialogBox2, 10, 40, 280, 195,
      "Controls");


   FMessageBox* MessageBox1 = new FMessageBox(Background1, 0, 0,
      "Message Box", F_OK_CANCEL, F_ARROW_ICON,
      "This is a simple test message.  If",
      "you need to let your users know",
      "information or answer a yes or no",
      "question, a message box is an ideal",
      "method to receive the response.");
   MessageBox1->Center();


   FMessageBox* MessageBox2 = new FMessageBox(Background1, 0, 0,
      "Error Handling", F_YES_NO, F_QUESTION_ICON,
      "", "This function will simulate a fatal",
      "error and terminate the program.",
      "Do you wish to continue?", "");
   MessageBox2->Center();


   FHelpWindow* HelpWindow1 = new FHelpWindow(Background1, "FastGUI Help",
      "guitest.hlp");


   FDialogBox* DialogBox3 = new FDialogBox(Background1, 0, 0, 230, 370,
      "About FastGUI Demo");
   DialogBox3->Center();
   FButton* Button5 = new FButton(DialogBox3, 0, 330, 80, 24, "OK");
   Button5->CenterX();

   FImageFile* ImageFile1 = new FImageFile(DialogBox3, 0, 0, 0, 0,
      "jim.pcx", F_PCX_FILE, F_CURRENT_PALETTE | F_CURRENT_POSITION);
   ImageFile1->Center();
   ImageFile1->MoveRel(0, 30);

   FText* Text1 = new FText(DialogBox3, 115, 57, 0,
      "FastGUI Demonstration Program", "Version 1.00a",
      "Copyright (c) 1996 James R. Boer", "All Rights Reserved");
   FBorder* Border3 = new FBorder(DialogBox3, 0, 0, 180, 270, F_RAISED);
   Border3->Center();



   Background1->Open();


   while(MenuItem8->IsNotClicked())
      {
      // get all mouse and keyboard events
      FInput::GetEvents();

      // processes all input events automatically
      Background1->HandleEvents();

      // now check for any events that were processed by Background1
      if(MenuItem3->IsClicked())
         {
         DialogBox1->Open();

         count = 0;
         while(Button1->IsNotClicked() && Button2->IsNotClicked())
            {
            // a very basic method to increment the Progress Bar
            if(count <= 100000L)
               {
               ProgressBar1->SetProgress(int(count / 1000));
               count++;
               }
            FInput::GetEvents();
            DialogBox1->HandleEvents();
            }
         DialogBox1->Close();
         }
      // check if the Graphic Buttons menu item was clicked

      else if(MenuItem4->IsClicked())
         {
         DialogBox2->Open();
         while(Button4->IsNotClicked())
            {
            FInput::GetEvents();
            DialogBox2->HandleEvents();
            if(CheckBox2->IsClicked())
               {
               if(CheckBox2->IsChecked())
                  {
                  GraphicButton1->SetDisabled(1);
                  GraphicButton1->Paint();
                  }
               else
                  {
                  GraphicButton1->SetDisabled(0);
                  GraphicButton1->Paint();
                  }
               }
            // switch colors back and forth
            else if(RadioButton4->IsClicked())
               {
               ColorButton1->SetColor(F_LIGHT_GREEN, F_WHITE, F_GREEN, F_BLACK,
                  F_BLACK);
               ColorButton1->Paint();
               }
            else if(RadioButton5->IsClicked())
               {
               ColorButton1->SetColor(F_LIGHT_RED, F_WHITE, F_RED, F_BLACK,
                  F_BLACK);
               ColorButton1->Paint();
               }
            }
         DialogBox2->Close();
         }
      // check if the Message Box menu item was clicked

      else if(MenuItem5->IsClicked())
         {
         MessageBox1->Open();
         while(MessageBox1->GetResponse() == F_NO_RESPONSE)
            {
            FInput::GetEvents();
            MessageBox1->HandleEvents();
            }
         MessageBox1->Close();
         }

      // check if the Fade In/Out menu item was clicked
      else if(MenuItem6->IsClicked())
         {
         FScreen::FadeOut(20);
         FScreen::FadeIn(20);
         }

      // check if the Error Handling menu item was clicked
      else if(MenuItem7->IsClicked())
         {
         MessageBox2->Open();
         while(MessageBox2->GetResponse() == F_NO_RESPONSE)
            {
            FInput::GetEvents();
            MessageBox2->HandleEvents();
            }
         if(MessageBox2->GetResponse() == F_YES_BUTTON)
            {
            MessageBox2->Close();
            delete MessageBox2;

            Background1->Close();
            delete Background1;

            FScreen::Close();
            FWindow::HandleError("This is a test error message.");
            }
         MessageBox2->Close();
         }
     // check if the Contents menu item was clicked

      else if(MenuItem9->IsClicked())
         {
         HelpWindow1->ReadPage(0);
         HelpWindow1->Open();
         while(HelpWindow1->GetResponse() != F_CLOSE_BUTTON)
            {
            FInput::GetEvents();
            HelpWindow1->HandleEvents();
            }
         HelpWindow1->Close();
         }
      // check if the Ordering Info menu item was clicked
      else if(MenuItem10->IsClicked())
         {
         HelpWindow1->ReadPage(2);
         HelpWindow1->Open();
         while(HelpWindow1->GetResponse() != F_CLOSE_BUTTON)
            {
            FInput::GetEvents();
            HelpWindow1->HandleEvents();
            }
         HelpWindow1->Close();
         }
      // check if the About menu item was clicked

      else if(MenuItem11->IsClicked())
         {
         DialogBox3->Open();
         while(Button5->IsNotClicked())
            {
            FInput::GetEvents();
            DialogBox3->HandleEvents();
            }
         DialogBox3->Close();
         }

      }

   // close the background

   Background1->Close();


   // Close FScreen class
   FScreen::Close();
   
   fg_setmode(3);
   fg_reset();


   delete Background1;

   delete MenuBar1;
   delete MenuItem1;
   delete MenuItem2;
   delete PullDownMenu1;
   delete MenuItem3;
   delete MenuItem4;
   delete MenuItem5;
   delete MenuItem6;
   delete MenuItem7;
   delete MenuItem8;
   delete PullDownMenu2;
   delete MenuItem9;
   delete MenuItem10;
   delete MenuItem11;

   delete DialogBox1;
   delete Button1;
   delete Button2;
   delete Button3;
   delete TEField1;
   delete CheckBox1;
   delete RBGroup1;
   delete RadioButton1;
   delete RadioButton2;
   delete RadioButton3;
   delete Slider1;
   delete Slider2;
   delete Border1;
   delete ProgressBar1;

   delete DialogBox2;
   delete CheckBox2;
   delete GraphicButton1;
   delete RBGroup2;
   delete RadioButton4;
   delete RadioButton5;
   delete ColorButton1;
   delete Button4;
   delete Border2;

   delete MessageBox1;

   delete MessageBox2;

   delete HelpWindow1;

   delete DialogBox3;
   delete Button5;
   delete ImageFile1;
   delete Text1;
   delete Border3;
   }


